<?php
/**
 * User: nester_a
 * Date: 29.10.13
 */

namespace LMS\Tools\Conference\Repositories;

use LMS\Tools\Conference\Table;
use LMS\Libraries\Base;

class Course extends Base\Repository
{
	public function __construct($options)
	{
		parent::__construct($options);
	}

    /**
     * Returns list of teachers for specified courseID
     *
     * @param int $courseID
     * @return mixed
     */
    public function getTeachers($courseID)
    {
        $query = "SELECT a.id as value, a.name as text FROM #__users as a, #__lms_user_courses as c"
            . "\n WHERE a.id = c.user_id AND c.course_id = '".$courseID."'"
            . "\n ORDER BY a.name";
        $this->db->SetQuery( $query );
        return $this->db->LoadObjectList();
    }

	public function getTeachersInfo($teachersID)
	{
		if(empty($teachersID)){
			return array();
		}

		$query = $this->db->getQuery(true);
		$query->select('*');
		$query->from('#__users');
		$query->where('id in (' . implode(',', $teachersID) . ')');

		$this->db->setQuery($query);
		return $this->db->loadObjectList();
	}

    /**
     * Returns list of students for specified course
     *
     * @param int $courseID
     * @return mixed
     */
    public function getStudents($courseID)
    {
        $query = "SELECT a.id as value, CONCAT(a.name, '(',  a.username, ')') as text, a.email, b.ug_name
                    FROM #__users as a,
                        #__lms_users_in_groups as c
                        LEFT JOIN
                            #__lms_usergroups as b ON c.group_id = b.id
                        AND
                            b.course_id = '".$courseID."'
                    WHERE
                        a.id = c.user_id
                    AND
                        c.course_id = '".$courseID."'
                    ORDER BY a.username";

        $this->db->SetQuery( $query );
        return $this->db->LoadObjectList();
    }

    /**
     * Return list of files for specified course
     *
     * @param int $courseID
     * @return mixed
     */
    public function getFiles($courseID)
    {
        $query = "SELECT a.*, b.file_srv_name
                        FROM `#__lms_conference_doc` AS a
                        LEFT JOIN #__lms_files AS b ON a.file_id=b.id
                            WHERE a.course_id='".$courseID."'
                        ORDER BY a.doc_id";
        $this->db-> setQuery($query);
        return $this->db->loadObjectList();
    }
}