<?php
namespace LMS\Tools\Courses\Tables;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class Courses extends Base\Table
{
	protected $alias = 'course';
	
	protected $fieldMap = array(
		'title' => 'course_name'
	);
	
	public function __construct()
	{
		parent::__construct( '#__lms_courses', 'id' );
	}

	protected function initRelations()
	{
		parent::initRelations(); // TODO: Change the autogenerated stub
		
		$this->relations = array(
			'owner' => array(
				'table' => ServiceLocator::get('joomlausers_table'),
				'type' => 'INNER',
				'condition' => '{parent.owner_id} = {child.id}',
				'capacity' => self::ONE
			)
		);
	}
}