<?php
 
namespace LMS\Tools\Mailbox\Controllers;

defined('_JEXEC') or die;

use LMS\Libraries\User;
use LMS\Libraries\Base;
 
class Mailbox extends Base\Controller
{	
	public function display($cachable = false, $urlparams = false)
	{	
		if(!$this->user->get('id')) {
			$this->setRedirect(sefRelToAbs('index.php?option=com_joomla_lms'));
			return JError::raiseError(401, JText::_('You are not authorized to view this resource'));
		}	
		
		$this->inbox();
	}
	
	public function inbox()
	{		
		if(!$this->user->get('id')) {
			$this->setRedirect(sefRelToAbs('index.php?option=com_joomla_lms'));
			return JError::raiseError(401, JText::_('You are not authorized to view this resource'));
		}
		
		$courseId = $this->config->get('course_id');
		
		$model	= $this->getModel('inbox');
		
		$this->populateModel($model);
			
		$model->setState('course_id', $courseId);
		$model->setState('recipient_id', $this->user->id);				
		
		$view	= $this->getView('mailbox', 'html');	

		$view->setModel($model, true);
		$view->inbox();
	}
	
	public function outbox()
	{
		if(!$this->user->get('id')) {
			$this->setRedirect(sefRelToAbs('index.php?option=com_joomla_lms'));
			return JError::raiseError(401, JText::_('You are not authorized to view this resource'));
		}
		$courseId = $this->config->get('course_id');
		
		$model	= $this->getModel('outbox');
		
		$this->populateModel($model);
		
		$model->setState('course_id', $courseId);		
		$model->setState('sender_id', $this->user->id);		
				
		$view	= $this->getView('mailbox', 'html');
		$view->setModel($model, true);
		$view->outbox();
	}	
}